Bug 191463 - Bash appears to be mishandling sub-processes that use recycled PIDs
Bash appears to be mishandling sub-processes that use recycled PIDs
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 2.1
Classification: Red Hat
Component: bash (Show other bugs)
2.1
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Tim Waugh
Ben Levenson
:
Depends On: IT#61189_IT#60427
Blocks: 143573
  Show dependency treegraph
 
Reported: 2006-05-12 04:42 EDT by Tim Waugh
Modified: 2007-11-30 17:06 EST (History)
2 users (show)

See Also:
Fixed In Version: RHBA-2006-0502
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-06-01 13:28:48 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tim Waugh 2006-05-12 04:42:03 EDT
+++ This bug was initially created as a clone of Bug #145124 +++

Description of problem:

Customer runs a BASH script that sleeps and executes tests in a loop.
Occasionally, sleep terminates prematurely, which causes errors.

From IT#60427:
I've found the interesting fact from strace log collected by my
reproduction. Whenever the problem happened, the pid which had been
used by the background job process right before was assigned to the
process. For instance, pid 29255 had been assigned to "test_sub.sh" in
test case at the first, nextly, it was assigned to "sleep". The sleep
process was dealed as background job. As the result, this problem
happened. In grep issue, this fact is applicable.

29255 21:28:53.966341 execve("/mnt/test/60427/testing/test_sub.sh",
["/mnt/test/60427/testing/test_sub"...], [/* 31 vars */] <unfinished ...>
229255 22:31:41.371266 execve("/bin/sleep", ["sleep", "10"], [/* 31
vars */] <unfinished ...>


Version-Release number of selected component (if applicable):
bash-2.05b-29


How reproducible:
Customer has supplied scripts that reproduce the problem, they are
attached to issue 61189.

Steps to Reproduce:
1. Run test scripts
2.
3.
  
Actual results:
Every now and then, sleep returns prematurely.

Expected results:
Sleep should not return prematurely.

Additional info:
Comment 4 Red Hat Bugzilla 2006-06-01 13:28:48 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2006-0502.html

Note You need to log in before you can comment on or make changes to this bug.